(* Copyright 2008, 2009 Michael Brunner *)

(* This file is part of LIPS.

  LIPS is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as 
	published by the Free Software Foundation, either version 3 of 
	the License, or (at your option) any later version.

  LIPS is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public 
	License along with LIPS.  If not, see 
	<http://www.gnu.org/licenses/>. *)

open Monad;;


module ExceptionT (M: MONAD): sig 
	include MONAD;;
(*	type 'a t;;
  val (>>=): 'a t -> ('a -> 'b t) -> 'b t;;
  val (>>): 'a t -> 'b t -> 'b t;;
  val return: 'a -> 'a t;;*)
  val raise: string -> 'a t;;
  val trywith: 'a t -> (string -> 'a t) -> 'a t;;
(*  val run: 'a t -> 'a;;*)
  val lift: 'a M.t -> 'a t;;
end;;


module StateT (S: TYPEWRAPPER) (M: MONAD) : sig 
	include MONAD;;
(*	type 'a t;;
  val (>>=): 'a t -> ('a -> 'b t) -> 'b t;;
  val (>>): 'a t -> 'b t -> 'b t;;
  val return: 'a -> 'a t;;*)
  val read_state: S.t t;;
  val write_state: S.t -> unit t;;
(*  val run: 'a t -> 'a;;*)
  val run_with: 'a t -> S.t -> 'a;;
  val lift: 'a M.t -> 'a t;;
end;;
