(* Copyright 2008 Christian Sternagel *)

(* This file is part of LIPS.

  LIPS is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as 
	published by the Free Software Foundation, either version 3 of 
	the License, or (at your option) any later version.

  LIPS is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public 
	License along with LIPS.  If not, see 
	<http://www.gnu.org/licenses/>. *)

type 'a result
type 'a t = Strng.t -> 'a result

val (>>=)       : 'a t -> ('a -> 'b t) -> 'b t
val (<|>)       : 'a t -> 'a t -> 'a t
val (>>)        : 'a t -> 'b t -> 'b t
val any_char    : char t
val between     : 'o t -> 'a t -> 'c t -> 'a t
val char        : char -> char t
val digit       : char t
val letter      : char t
val many1       : 'a t -> ('a list) t
val many        : 'a t -> ('a list) t
val none_of     : string -> char t
val one_of      : string -> char t
val parse       : 'a t -> Strng.t -> 'a option 
val return      : 'a -> 'a t
val sat         : (char -> bool) -> char t
val sep_by1     : 'a t -> 's t -> ('a list) t
val sep_by      : 'a t -> 's t -> ('a list) t
val sep_end_by1 : 'a t -> 's t -> ('a list) t
val sep_end_by  : 'a t -> 's t -> ('a list) t
val skip_many1  : 'a t -> unit t
val skip_many   : 'a t -> unit t
val space       : char t
val spaces      : unit t
val string      : string -> Strng.t t
val tempt       : 'a t -> 'a t
val test        : 'a t -> string -> 'a

val many_until  : 'a t -> 'b t -> ('a list) t
val many_before  : 'a t -> 'b t -> ('a list) t
val spaces1     : unit t
val parse_strict: 'a t -> Strng.t -> 'a option 
