(* Copyright 2008 Christian Sternagel *)

(* This file is part of LIPS.

  LIPS is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as 
	published by the Free Software Foundation, either version 3 of 
	the License, or (at your option) any later version.

  LIPS is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public 
	License along with LIPS.  If not, see 
	<http://www.gnu.org/licenses/>. *)

type 'a t
val diff : 'a t -> 'a t -> 'a t
val empty : 'a t
val filter : ('a -> bool) -> 'a t -> 'a t
val insert : 'a -> 'a t -> 'a t
val is_empty : 'a t -> bool
val mem : 'a -> 'a t -> bool
val fold: ('a -> 'b -> 'b) -> 'b -> 'a t -> 'b
val remove : 'a -> 'a t -> 'a t
val of_list : 'a list -> 'a t
val print_st :
 (Format.formatter -> 'a -> unit) -> Format.formatter -> 'a t -> unit
val singleton : 'a -> 'a t
val to_list : 'a t -> 'a list
val union : 'a t -> 'a t -> 'a t

val has_one : ('a -> bool) -> 'a t -> bool
val find_by : ('a -> bool) -> 'a t -> 'a
val remove_by : ('a -> bool) -> 'a t -> 'a t
val replace_by : ('a -> bool) -> 'a -> 'a t -> 'a t